searchNodes=[{"doc":"Req plugin for :fuse ReqFuse provides circuit-breaker (or load-shedding) functionality for HTTP requests that use the Req library. Usage After adding the dependencies, simply attach the ReqFuse step to your request ensuring you are passing in the required and any optional fuse configuration. Mix . install ( [ { :req , &quot;~&gt; 0.3&quot; } , { :req_fuse , &quot;~&gt; 0.2&quot; } ] ) req_fuse_opts = [ fuse_name : My.Example.Fuse ] req = [ url : &quot;https://httpstat.us/500&quot; , retry : :never ] |&gt; Req . new ( ) |&gt; ReqFuse . attach ( req_fuse_opts ) # Fire the request enough times to melt the fuse Enum . each ( 0 .. 10 , fn _ -&gt; Req . request ( req ) end ) =&gt; :ok Req . request ( req ) =&gt; 08 : 45 : 42.518 [ warning ] :fuse circuit breaker is open ; fuse = Elixir.My.Example.Fuse =&gt; { :error , % RuntimeError { message : &quot;circuit breaker is open&quot; } } Installation If available in Hex , the package can be installed by adding req_fuse to your list of dependencies in mix.exs : def deps do [ { :req_fuse , &quot;&gt;= 0.2.0&quot; } ] end","ref":"ReqFuse.html","title":"ReqFuse","type":"module"},{"doc":"See ReqFuse.Steps.Fuse.attach/2 .","ref":"ReqFuse.html#attach/2","title":"ReqFuse.attach/2","type":"function"},{"doc":"Configure circuit-breaker via :fuse .","ref":"ReqFuse.Steps.Fuse.html","title":"ReqFuse.Steps.Fuse","type":"module"},{"doc":"Attach the circuit-breaker :fuse step and configure the supported options. Fuse Options :fuse_melt_func - A 1-arity function to determine if response should melt the fuse defaults to ReqFuse.Steps.Fuse.melt?/1 :fuse_mode - how to query the fuse, which has two values: :sync - queries are serialized through the :fuse_server process (the default) :async_dirty - queries check the fuse state directly, but may not account for recent melts or resets :fuse_name - REQUIRED the name of the fuse to install :fuse_opts The fuse strategy options (see fuse docs for reference) (order matters) defaults to {{:standard, 10, 10000}, {:reset, 30000}} . See defaults/0 for more information. :fuse_verbose - If false, suppress Log output See https://github.com/jlouis/fuse#tutorial for more information about the supported fuse strategies and their options. Melt function By default ReqFuse will send a melt message to your fuse server for any request where the status is over 500. There are many other melt options. The melt_function must be a 1-arity function that evaluates the response. Pass the function reference in the :fuse_melt_func key as &amp;Mod.fn/arity (or MFA notation). Any melt function should be widely permissive of what it will evaluate. In addition to a %Req.Response{} it could receive other error state messages from the underlying HTTP adapter libraries. For example: {:error, %Mint.TransportError{reason: :econnrefused}} {:error, %Mint.TransportError{reason: :timeout}} {:error, %HTTPoison{}} some_other_flavor_of_error Example melt?/1 function def melt? ( % Req.Response { } = response ) do cond do response . status in [ 408 , 429 ] -&gt; true response . status &gt;= 200 and response . status &lt; 300 -&gt; false response . status &lt; 200 -&gt; true end def melt? ( % Req.Response { } ) , do : false def melt? ( error_response ) , do : true Options Example [ fuse_melt_func : &amp; My.Fuse.CustoMod . my_melt_function / 1 , fuse_mode : :sync , fuse_name : My.Fuse.Name , fuse_opts : { { :standard , 1 , 1000 } , { :reset , 300 } } , fuse_verbose : true ]","ref":"ReqFuse.Steps.Fuse.html#attach/2","title":"ReqFuse.Steps.Fuse.attach/2","type":"function"},{"doc":"(Hopefully) reasonable fuse defaults, based on the fuse docs: {{:standard, 10, 10000}, {:reset, 30000}} . fuse type first tuple - Specify the fuse strategy (:standard or :fault_injection), :standard, permit N (3) failures in M (10_000) milliseconds {:standard, N, M} {:standard, 3, 10_000} :fault_injection, This fuse type sets up a fault injection scheme where the fuse fails at rate R (0.005), N (3) and M (10_000) work similar to :standard. e.g. {:fault_injection, 0.005, 3, 10_000} {:fault_injection, R, N, M} (Inject one fault for 0.5% of requests, 3 failures in 10 seconds melts the fuse) second tuple - Specify the recover period in milliseconds e.g. {:reset, 30_000} unmelt the fuse after 30 seconds. {:reset, 30_000}","ref":"ReqFuse.Steps.Fuse.html#defaults/0","title":"ReqFuse.Steps.Fuse.defaults/0","type":"function"},{"doc":"A default :fuse melt test.","ref":"ReqFuse.Steps.Fuse.html#melt?/1","title":"ReqFuse.Steps.Fuse.melt?/1","type":"function"},{"doc":"Telemetry integration for fuse events. Runtime Events [:req_fuse, :blown] - This event will fire whenever a fuse is checked and is in a blown state. Metadata :fuse_name - the name of the fuse","ref":"ReqFuse.Telemetry.html","title":"ReqFuse.Telemetry","type":"module"},{"doc":"","ref":"ReqFuse.Telemetry.html#blown_fuse/1","title":"ReqFuse.Telemetry.blown_fuse/1","type":"function"},{"doc":"ReqFuse on Github https://github.com/carsdotcom/req_fuse ReqFuse on Hex https://hex.pm/packages/req_fuse ReqFuse on HexDocs https://hexdocs.pm/req_fuse Req plugin for :fuse ReqFuse provides circuit-breaker (or load-shedding) functionality for HTTP requests that use the Req library.","ref":"readme.html","title":"ReqFuse","type":"extras"},{"doc":"After adding the dependencies, simply attach the ReqFuse step to your request ensuring you are passing in the required and any optional fuse configuration. Mix . install ( [ { :req , &quot;~&gt; 0.3&quot; } , { :req_fuse , &quot;~&gt; 0.2&quot; } ] ) req_fuse_opts = [ fuse_name : My.Example.Fuse ] req = [ url : &quot;https://httpstat.us/500&quot; , retry : :never ] |&gt; Req . new ( ) |&gt; ReqFuse . attach ( req_fuse_opts ) # Fire the request enough times to melt the fuse Enum . each ( 0 .. 10 , fn _ -&gt; Req . request ( req ) end ) =&gt; :ok Req . request ( req ) =&gt; 08 : 45 : 42.518 [ warning ] :fuse circuit breaker is open ; fuse = Elixir.My.Example.Fuse =&gt; { :error , % RuntimeError { message : &quot;circuit breaker is open&quot; } }","ref":"readme.html#usage","title":"ReqFuse - Usage","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding req_fuse to your list of dependencies in mix.exs : def deps do [ { :req_fuse , &quot;&gt;= 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"ReqFuse - Installation","type":"extras"},{"doc":"Attach the circuit-breaker :fuse step and configure the available options Fuse Options :fuse_melt_func - A 1-arity function to determine if response should melt the fuse defaults to ReqFuse.Steps.Fuse.melt?/1 :fuse_mode - how to query the fuse, which has two values: :sync - queries are serialized through the :fuse_server process (the default) :async_dirty - queries check the fuse state directly, but may not account for recent melts or resets :fuse_name - REQUIRED the name of the fuse to install :fuse_opts The fuse strategy options (see fuse docs for reference) (order matters) See ReqFuse.Steps.Fuse.defaults/0 for more information. :fuse_verbose - If false, suppress Log output See https://github.com/jlouis/fuse#tutorial for more information about the supported fuse strategies and their options. See also the additional discussion on options in ReqFuse.Steps.Fuse","ref":"readme.html#twiddling-the-knobs","title":"ReqFuse - Twiddling the Knobs","type":"extras"},{"doc":"See LICENSE","ref":"readme.html#license","title":"ReqFuse - License","type":"extras"},{"doc":"See CHANGELOG.md Updating the changelog. (Uses auto-changelog ) https://github.com/cookpete/auto-changelog auto-changelog --breaking-pattern &quot;BREAKING CHANGE&quot; --template keepachangelog --commit-limit false --unreleased Tagging by version in mix.exs git tag ` grep - e &#39;@version \\&quot; \\d \\. \\d \\. \\d \\&quot; .*&#39; mix . exs | awk &#39;{gsub(/&quot;/, &quot;&quot;, $2); print $2}&#39; `","ref":"readme.html#updates","title":"ReqFuse - Updates","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog and this project adheres to Semantic Versioning . Generated by auto-changelog .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Commits refactor: use :update for deprecation 8764634 chore: update changelog changes b82938c bump version bafb1b2","ref":"changelog.html#0-2-3-2023-04-18","title":"Changelog - 0.2.3 - 2023-04-18","type":"extras"},{"doc":"Commits docs: Update docs 27cc316 chore: update Changelog d11b585 chore: move description from file into function. ac0b626 chore: Update description and readme link 8618488 chore: Fix typos in docs b688e95 deps: update Req d24968f deps: update telemetry f7d7d07 another typo 516b5fd","ref":"changelog.html#0-2-2-2023-03-15","title":"Changelog - 0.2.2 - 2023-03-15","type":"extras"},{"doc":"Merged relax dependency for wider use #4 Add fuse to error steps #1 add telemetry events for fuse state #3 remove stray git artifacts #2 Commits bugfix: prepend fuse to error steps c3ff99b docs(README) clarify docs 1037b32 chore(GitHub actions) add elixir.yml 1366c86 Update docs 11145d5 add melt tests 42461a3 docs(*.md) update CHANGELOG and README ed63c24 documentation: update doc and version refs 19a480c update actions workflow 84a6b5f chore: bump version 45e1c8c chore update elixir version for GH actions, add badge 4dbcb54 chore update elixir version for GH actions b793b61","ref":"changelog.html#0-2-1-2023-02-23","title":"Changelog - 0.2.1 - 2023-02-23","type":"extras"},{"doc":"Commits chore(CHANGELOG) add CHANGELOG.md 51442eb chore(bump version) to 0.1.1 ca0fb4b","ref":"changelog.html#0-1-1-2022-11-01","title":"Changelog - 0.1.1 - 2022-11-01","type":"extras"},{"doc":"Commits ReqFuse initial commit 6b88041 docs(Fuse): Improve docs for melt?/1 77be6f4 changed(ReqFuse): added delegation for attach.2 905e1fc doc(README): add changelog and tagging info. a9814fb Added: ln logo to fuse 0b79e9b","ref":"changelog.html#0-1-0-2022-11-01","title":"Changelog - 0.1.0 - 2022-11-01","type":"extras"}]